/*******************************(i2c-MEM.c)**************
 *	I2CڑpCu(M24M02/24FC1025 & 47C16)
 ***********************************************************/

#define ROM_24FC1025 0      // lOɂdefinƂȂ
#define ROM_M24M02   2      // lOɂdefinƂȂ

#define ROM_ADR	0x50
#define RAM_ADR 0x52        // M24M02 & 47C16̏ꍇ

#define MBFSIZE	64      // pobt@[TCY

#include "mcc_generated_files/mcc.h"
#include "mcc_generated_files/examples/i2c1_master_example.h"
#include "i2c_SSD1306.h"
#include "ctype.h"          // isxdigit()
#include "stdio.h"          // puts(),..
#include "stdlib.h"         // atoi()...
#include "string.h"         // strtok()...
//#include <errno.h>
#include "myProject.h"

//=== O[oϐ ========================
static char     Dlm[] = ",";       // ؂f~^

//--- I2C[p
static uint8_t  Device = 0;        // foCXEubNԍ
static uint32_t CrtAdr = 0;        // JgAhX
static uint8_t  DBuf[MBFSIZE+2];     // y[Wpobt@[
static uint8_t  SqMode;            // A[hi=1jH
static char     SBuf[31];          // \pi1ső30j
static uint8_t  LstCmd;            // (ŏIj̃R}h
static uint16_t LstChr = 0;         // ŏI\
//static uint8_t  fntPtn[32];         // tHgp^[p

/*********************************************
 *  I2C EEPROM function
 **********************************************/

//----  foCX̃AhXubNvZ
uint8_t calcDev(uint32_t adr){
    uint8_t dv;
    if(adr < 0x80000){
#if  ROM_24FC1025
        dv = ROM_ADR + (uint8_t)(adr >> 17);
        if(adr & 0x10000) dv += 0x04;
#elif ROM_M24M02
        dv = ROM_ADR + (uint8_t)(adr >> 16);
        dv += 0x04;            // E = high  
#endif
    }else{
        dv = RAM_ADR;
    }
    return dv;
}
 
//-----  AhXadrA1oCgǂݏo
uint8_t I2C_Mem_Read(uint32_t adr){
    uint8_t bf[2];
    Device = calcDev(adr);
    bf[0] = (uint8_t)((adr & 0x1FFFF) >> 8);
    bf[1] = (uint8_t)adr;               // AhXZbg
    I2C1_WriteNBytes(Device, bf, 2);    // AhXM
    I2C1_ReadNBytes(Device, bf, 1);     // f[^Ǎ
    return bf[0];
}

//-----  AhXadrɁA1oCgdt
void I2C_Mem_Write(uint32_t adr, uint8_t dt){
    uint8_t bf[3];
    Device = calcDev(adr);
    bf[0] = (uint8_t)((adr & 0x1FFFF) >> 8);
    bf[1] = (uint8_t)adr;               // AhXZbg
    bf[2] = dt;                         // f[^Zbg
    I2C1_WriteNBytes(Device, bf, 3);    //
    __delay_ms(5);
}
//-----  AhXadr炎oCgary[]ɓǂݏo
void I2C_Mem_NRead(uint32_t adr, uint8_t *ary, uint8_t n){
    uint8_t bf[2];
    Device = calcDev(adr);
    bf[0] = (uint8_t)((adr & 0x1FFFF) >> 8);
    bf[1] = (uint8_t)adr;               // AhXZbg
    if(n > MBFSIZE) n = MBFSIZE;
    I2C1_WriteNBytes(Device, bf, 2);    // AhXM
    I2C1_ReadNBytes(Device, ary, n);    // noCgǍ
}

//-----  AhXadrary[]noCg
void I2C_Mem_NWrite(uint32_t adr, uint8_t  *ary, uint8_t n){
    uint8_t bf[MBFSIZE + 2];
    Device = calcDev(adr);
    bf[0] = (uint8_t)((adr & 0x1FFFF) >> 8);
    bf[1] = (uint8_t)adr;               // y[WEɒӁI
    if(n > MBFSIZE) n = MBFSIZE;
    memcpy(bf+2,ary,n);                 // ary[]bf[]ɃRs[
    I2C1_WriteNBytes(Device, bf, n+2);  // noCg
    __delay_ms(5);
}

/****** ėpTu[`@********************/
//---- 16i10iɕϊ
int32_t my_xtoi(char *str){
    uint32_t dec;
    dec = strtoul(str,NULL,16);
//    if(errno == ERANGE) return -1;          // ϊG[
    return (int32_t)dec;
}

//   16iϊ  uint16 -> str(Hex)
uint8_t my_utoa2(uint16_t n){
    n &= 0x0F;
    if(n < 10)  return '0'+ (uint8_t)n;
    else        return 'A'+ ((uint8_t)n - 10);
}

void my_utoa(uint8_t *str, uint16_t wd, uint8_t dg){
    if(dg > 3)  *str++ = my_utoa2(wd >> 12);
    if(dg > 2)  *str++ = my_utoa2(wd >> 8);
    if(dg > 1)  *str++ = my_utoa2(wd >> 4);
    *str++ = my_utoa2(wd);
    *str = '\0';
}

//---  o͊֐iWo͂ցj
void my_puts(char *str){            // ̂ݏo
    while(*str) putch(*str++);
}

void my_putsLf(char *str){          // sɈړiLF)t
    my_puts(str);
    putch('\r');
}

//---- y[Wobt@[vg
void prt_PBf(uint8_t *cBf, uint16_t n){
    uint16_t i;
    for(i = 0; i < n; i++){
        if(i % 16 == 0) putch('\r');
        my_utoa((uint8_t *)SBuf,cBf[i],2);
        putch(SBuf[0]); putch(SBuf[1]); putch(' ');
        if(i < 48){
            if(i % 8 == 0) i2cOLED_posPX(i2cOLED_LF(),0);
//	        my_utoa((uint8_t *)SBuf,cBf[i],2);
	        strcat(SBuf," ");
            i2cOLED_str(SBuf);
        }
    }
    puts("\r");
}

//---- 20rbgAhX8rbgf[^16iŕɊi[
void sPrt_AdrDt(char *strP,uint32_t adr, uint8_t dt, char ch){
    uint16_t a16;
    uint8_t  h;
    h = (uint8_t)((adr>>16) & 0x0F);
    *strP++ = my_utoa2(h);
    a16 = (uint16_t)(adr & 0x0FFFF);
    my_utoa((uint8_t *)strP,a16,4);
    strP += 4;
    *strP++ = ' '; *strP++ = ch; *strP++ =' ';
    my_utoa((uint8_t *)strP,(uint16_t)dt,2);
    strP += 2;
    *strP = '\0';
}

//---- 20rbgAhX120rbgAhX216iŕɊi[
void sPrt_AdrAdr(char *strP,uint32_t adr1, uint32_t adr2, char ch){
    uint16_t a16;
    uint8_t  h;
    h = (uint8_t)((adr1>>16) & 0x0F);
    *strP++ = my_utoa2(h);
    a16 = (uint16_t)(adr1 & 0x0FFFF);
    my_utoa((uint8_t *)strP,a16,4);
    strP += 4;
    *strP++ = ' '; *strP++ = ch; *strP++ =' ';
    h = (uint8_t)((adr2>>16) & 0x0F);
    *strP++ = my_utoa2(h);
    a16 = (uint16_t)(adr2 & 0x0FFFF);
    my_utoa((uint8_t *)strP,a16,4);
    strP += 4; 
    *strP = '\0';
}

//----- RAM Status & Command
uint8_t I2C_RAM_CmdRead(){
    uint8_t bf[2];
	Device = 0x1A;
	I2C1_ReadNBytes(Device,bf,1);
	return bf[0];
}

void read_RAM_cmd(){
	uint8_t cm;
	cm = I2C_RAM_CmdRead();
	my_utoa((uint8_t *)SBuf,cm,2);
	my_putsLf(SBuf);
}

void I2C_RAM_CmdWrite(uint8_t adr, uint8_t dt){
    uint8_t bf[3];
    Device = 0x1A;
    bf[0] = Device;
    bf[1] = adr;                        // AhXZbg
    bf[2] = dt;                         // f[^Zbg
    I2C1_WriteNBytes(Device, bf, 3);    //
    __delay_ms(5);
    my_putsLf("Set Status");
}

/*********************************************
 * 		R}hANV
 *********************************************/
//----- vR}h   W[aaaa][,][d0,][,]
uint16_t i2cMem_cmd_W(char *str){
    char     *pt;                   // 񑀍p|C^
    uint8_t  last;                  // ̍Ō̈ʒu
    int32_t  res = 0;               // Hexlϊ
    uint8_t  dt = 0;                // ރoCgf[^
    uint16_t cnt = 0;               // ۂɏ񂾃oCg

    LstCmd = str[0];
    if(strlen(str)==1){             // 'W'݂̂Ȃ
        SqMode = 1;                 // A[hɃZbg
#ifndef VBA
        puts("SqMode ON\n\r");
#endif
        return 0;                   // f[^͏܂Ȃ
    }
    last = (uint8_t)strlen(str)-1;  // ̍sʒu擾
    if(str[last] == ','){           // sR}Ȃ
        SqMode = 1;                 // A[hɃZbg
#ifndef VBA
        puts("SqMode ON\n\r");
#endif
        str[last]='\0';             // s̃R}
    }
    if(str[1]!=','){
        pt = strtok(str+1,Dlm);     // R}h̎
        if(pt != NULL){             // AhXf[^
            res = my_xtoi(pt);
//            if(res < 0) return cnt; // ϊG[
            CrtAdr = (uint32_t)res;
        }
        pt = strtok(NULL,Dlm);      // 
    }else{
        pt= strtok(str+1,Dlm);      // 擾
    }
    i2cOLED_Clr(0,7,0);
    do{
        if(pt != NULL){
            res = my_xtoi(pt);
//            if(res < 0) return cnt;
            dt = (uint8_t)res;
            if(LstCmd=='W'){         // R}h'W'
                I2C_Mem_Write(CrtAdr,dt);
            }else if(LstCmd == 'S'){ // R}h'S'
                DBuf[CrtAdr & 0x3F]= dt; // 64oCg܂
            }
            sPrt_AdrDt(SBuf,CrtAdr,dt,'<');
            my_putsLf(SBuf);
            i2cOLED_str(SBuf);
            i2cOLED_posPX(i2cOLED_LF(),0);
            CrtAdr++; cnt++;
            pt = strtok(NULL,Dlm);  // 
        }
    }while(pt != NULL);
    return cnt;
}

//---- qR}h  R[aaaa][,n]
uint16_t i2cMem_cmd_R(char *str){
    char *pt;                   // 񑀍p|C^
    uint16_t n = 1;             // w肳ꂽǍoCg
    int32_t  res = 0;           // Hexlϊ
    uint8_t  dt;                // ǂݍ񂾃oCgf[^
    uint16_t cnt = 0;           // ۂɓǂݏoꂽoCg
    uint8_t  i;                 // [vϐ

    LstCmd = str[0];
    if(strlen(str) > 1){
        if(str[1]==','){
            pt = strtok(str+2,Dlm);
            if(pt != NULL){             // H
                res = my_xtoi(pt);
//                if(res < 0) return cnt;
                n = (uint16_t)res;
            }          
        }else{
            pt = strtok(str+1,Dlm);
            if(pt != NULL){             // address?
                res = my_xtoi(pt);
//                if(res < 0) return cnt;
                CrtAdr = (uint32_t)res;
            }
            pt = strtok(NULL,Dlm);      // 
            if(pt != NULL){             // H
                res = my_xtoi(pt);
//                if(res < 0) return cnt;
                n = (uint16_t)res;
            }
        }
    }
    i2cOLED_Clr(0,7,0);
    for(i = 0; i < n;i++ ){
        dt = I2C_Mem_Read(CrtAdr);  // oCgf[^ǂݏo
        sPrt_AdrDt(SBuf,CrtAdr,dt,'<');
        my_putsLf(SBuf);
        i2cOLED_str(SBuf);
        i2cOLED_posPX(i2cOLED_LF(),0);
        CrtAdr++; cnt++;
    }
    SqMode = 0;
    return cnt;
}

//---- WSQ R}hiA[hj
uint16_t i2cMem_cmd_WSQ(char *str){
    char     *pt;               // 񑀍p|C^
    uint8_t  dt;                // ރoCgf[^
    int32_t  res;               // Hexlϊ
    uint16_t cnt = 0;           // ۂɓǂݏoꂽoCg
    pt = strtok(str,Dlm);	
    while(pt != NULL){
        res = my_xtoi(pt);
//        if(res < 0) return cnt;
        dt = (uint8_t)res;
        I2C_Mem_Write(CrtAdr,dt);  // f[^
        sPrt_AdrDt(SBuf,CrtAdr,dt,'<');
        my_putsLf(SBuf);
        i2cOLED_str(SBuf);
        CrtAdr++; cnt++;
        pt = strtok(NULL,Dlm);  // 
    }
    return cnt;
}

//---- pR}hiA[h̉j   Q
void i2cMem_cmd_Q(char *str){
    SqMode = 0;
#ifndef VBA
    puts("SqMode OFF\r");
#endif
}

//---- t(dump)R}hi64oCg̃f[^DBuf[]ɓǂݏo)
int i2cMem_cmd_U(char *str){
    char     *pt;               // 񑀍p|C^
    int32_t  res;               // Hexlϊ
    uint32_t ad;                // wAhX
    uint8_t  i;                 // [vJE^p

    LstCmd = str[0];
    pt = strtok(str+1,Dlm);
    if(pt != NULL){             // AhXLH
        res = my_xtoi(pt);
//        if(res < 0) return -1;
        CrtAdr = (uint32_t)res;
    }
    ad = CrtAdr & 0xFFFE0;      // 32oCgPʂ 
    I2C_Mem_NRead(ad,DBuf,64);  // 64oCgDBuf[]ɓǏo
    sPrt_AdrAdr(SBuf,ad,ad + MBFSIZE - 1,'-');
    my_puts(SBuf);
    i2cOLED_Clr(0,7,0);
    i2cOLED_str(SBuf);
    i2cOLED_posPX(i2cOLED_LF(),0);
    prt_PBf(DBuf,MBFSIZE);
	SqMode = 0;    
    return 0;
}

void prt_MemDat(uint32_t adr){
    if(LstCmd == 'H'){                  // 2HH
        I2C_Mem_NRead(adr, DBuf, 16);    // 16oCgDBuf[]ɓǏo
        i2cOLED_Ptn(0,0,2,8,(char *)DBuf);
        i2cOLED_posPX(2,0);
        prt_PBf(DBuf,16);
    }else{
        I2C_Mem_NRead(adr, DBuf, 32);  // 32oCgDBuf[]ɓǏo
        i2cOLED_Ptn(0,0,2,16,(char *)DBuf);
        i2cOLED_posPX(2,0);
        prt_PBf(DBuf,32);
    }    
}

//--  tHgp^[f[^̕\
int i2cMem_cmd_u(char *str){
    char    *pt;                        // 񑀍p|C^
    uint32_t res;                       // Hexlϊ
    uint32_t ad;                        // wAhX

    pt = strtok(str+1,Dlm);
    if(pt != NULL){                     // AhXLH
        res = (uint32_t)my_xtoi(pt);
        CrtAdr = res;
    }
    ad = CrtAdr & 0xFFFFF0;             // 16oCgPʂ 
    prt_MemDat(ad);
    SqMode = 0;
    return 0;
}

//---- o(Page)R}h    PW[aaaa]
//          iDBuf[]64oCgɏށj
int i2cMem_cmd_P(char *str){
    char     *pt;                       // 񑀍p|C^
    uint32_t res;                       // Hexlϊ
    uint32_t ad;                        // wAhX
    static char msgP[] = "PageBuffer";

    LstCmd = str[0];
    if(strlen(str)==1){                 // R}h'P'̂
        puts(msgP);                     // y[Wf[^\
        i2cOLED_Clr(0,7,0);
        i2cOLED_str(msgP);
        i2cOLED_posPX(i2cOLED_LF(),0);
        prt_PBf(DBuf,MBFSIZE);
        return 0;
    }
    if(str[1]=='R'){                    // 2='R'
        i2cMem_cmd_U(str+1);            // UR}hƓ
        return 0;
    }
    if(str[1] != 'W') return -1;        // 2'W'H
    pt = strtok(str+2,Dlm);
    if(pt != NULL){                     // AhXLH
        res = (uint32_t)my_xtoi(pt);
        CrtAdr = (uint32_t)res;
    }
    ad = CrtAdr & 0xFFFC0;              // 64oCgPʂ
    I2C_Mem_NWrite(ad,DBuf,64);         // DBuf[]64oCg
    sPrt_AdrAdr(SBuf,ad,ad + MBFSIZE - 1,'-');
    my_putsLf(SBuf);
    i2cOLED_Clr(0,7,0);
    i2cOLED_str(SBuf);
    SqMode = 0;    
    return 0;
}

//----  V[PX[h̊mF
uint8_t i2cMem_SqMode(){
	return SqMode;
}

//---- K(j\R}h  K[H][aaaa] 
int i2cMem_cmd_K(char *str){
    char *sp;
    uint8_t  cn;                        // Rhbg
    uint8_t  ofs;                       // ǃItZbg
    uint8_t  i,n;                       // [vϐ
    int32_t  res;                       // 擾AhX

    LstCmd = str[0];
    if((strlen(str)>1)&(str[1]=='H')){
		ofs = 2; cn = 8;
    }else{
		ofs = 1; cn = 16;
	}
    sp = strtok(str+ofs,Dlm);
    if(sp != NULL){
        res = my_xtoi(sp) & 0xFFFF0;   // 16oCgP
        if(res>0) CrtAdr = (uint32_t)res;
    }
    i2cOLED_Clr(0,7,0);
    sPrt_AdrAdr((char *)SBuf, CrtAdr, CrtAdr+16*cn-1,'-');
    my_putsLf((char *)SBuf);
    i2cOLED_str(SBuf);
    n = 8 * ofs;
    for(i = 0; i < n; i++){
        I2C_Mem_NRead(CrtAdr,(uint8_t *)DBuf,2*cn);
        i2cOLED_Ptn(2,i*cn,2,cn,(char *)DBuf);
        CrtAdr += 2*cn;
    }
    SqMode = 0;
    return i;
}


//---- L(j\R}h  L[code] iR[hj
void i2cMem_cmd_L(char *str){
    char     *pt;                       // 񑀍p|C^
    uint32_t res;                       // Hexlϊ
    uint16_t ftCd = 0;                  // tHgR[h
    
    LstCmd = str[0];
    if(strlen(str)==1){                 // AhX	
        LstChr += 1;                    // 
    }else{
        pt = strtok(str+1,Dlm);
        if(pt != NULL){                 // AhXLH
            res = (uint32_t)my_xtoi(pt);
            if(res>0)   LstChr = (uint16_t)res;
        }
    }
    i2cOLED_Clr(0,7,0);
    my_utoa((uint8_t *)SBuf,LstChr,4); my_putsLf(SBuf);
    i2cOLED_str(SBuf);
    if(LstChr < 256){
        i2cOLED_HchrX(32,0,(uint8_t)LstChr);
        I2C_Mem_NRead(HfntAdr((uint8_t)LstChr),DBuf,16);
        i2cOLED_posPX(2,0);
        prt_PBf(DBuf,16);
    }else{
        i2cOLED_ZchrX(32,0,LstChr,2);
        I2C_Mem_NRead(KfntAdr(LstChr),DBuf,32);
        i2cOLED_posPX(2,0);
        prt_PBf(DBuf,32);
    }
    SqMode = 0;
}

/******  End of File **************************/
